<?php

namespace Ulmus\Query;

class Insert extends Fragment {

    const SQL_INSERT_TOKEN = "INSERT";

    const SQL_REPLACE_TOKEN = "REPLACE";

    public int $order = -100;

    public bool $quick = false;

    public bool $replace = false;

    public bool $ignore = false;
    
    public array $fieldlist = [];
    
    public string $priority;
    
    public string $table;
    
    public ? string $alias = null;

    public function render() : string
    {
        return $this->renderSegments([
            $this->replace ? static::SQL_REPLACE_TOKEN : static::SQL_INSERT_TOKEN,
            ( $this->priority ?? false ),
            ( $this->ignore ? 'IGNORE' : false ),
            'INTO', $this->table, 
            "(" . implode(',', $this->fieldlist) . ")",
        ]);
    }
}
